package org.jboss.errai.ui.nav.client.local.spi;

import com.kdm.erraiexample.client.ContentPage;
import java.util.HashMap;
import java.util.Map;
import org.jboss.errai.common.client.PageRequest;
import org.jboss.errai.common.client.util.CreationalCallback;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ui.nav.client.local.DefaultPage;
import org.jboss.errai.ui.nav.client.local.HistoryToken;
import org.jboss.errai.ui.nav.client.local.api.NavigationControl;
import org.jboss.errai.ui.nav.client.shared.NavigationEvent;

public class GeneratedNavigationGraph extends NavigationGraph { public GeneratedNavigationGraph() {
    final PageNode defaultPage = new PageNode<ContentPage>() {
      public String name() {
        return "ContentPage";
      }

      public Class contentType() {
        return ContentPage.class;
      }

      public void produceContent(CreationalCallback callback) {
        bm.lookupBean(ContentPage.class).getInstance(callback);
      }

      public void pageHiding(ContentPage widget, NavigationControl control) {
        control.proceed();
      }

      public void pageHidden(ContentPage widget) {

      }

      public void pageShowing(ContentPage widget, HistoryToken state) {
        final Map pageState = new HashMap() {
          {

          }
        };
        CDI.fireEvent(new NavigationEvent(new PageRequest("ContentPage", pageState)));
      }

      public void pageShown(ContentPage widget, HistoryToken state) {
        final Map pageState = new HashMap() {
          {

          }
        };
      }

      public void destroy(ContentPage widget) {
        bm.destroyBean(widget);
      }
    };
    pagesByName.put("", defaultPage);
    pagesByRole.put(DefaultPage.class, defaultPage);
    final PageNode contentPage = defaultPage;
    pagesByName.put("ContentPage", contentPage);
  }

}