package org.jboss.errai.marshalling.client.api;

import com.kdm.provider.data.Facet;
import com.kdm.provider.data.Field;
import java.util.ArrayList;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;

public class Marshaller_for_com_kdm_provider_data_Facet_Impl implements GeneratedMarshaller<Facet> {
  private Facet[] EMPTY_ARRAY = new Facet[0];
  private Marshaller<Long> java_lang_Long = Marshalling.getMarshaller(Long.class);
  private Marshaller<ArrayList> java_util_ArrayList = null;
  private Marshaller<Field> com_kdm_provider_data_Field = null;
  public Facet[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  public Facet demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(Facet.class, objId);
    }
    Facet entity = new Facet();
    a1.recordObject(objId, entity);
    if ((obj.containsKey("count")) && (!obj.get("count").isNull())) {
      entity.setCount(java_lang_Long.demarshall(obj.get("count"), a1));
    }
    if ((obj.containsKey("entries")) && (!obj.get("entries").isNull())) {
      a1.setAssumedElementType("com.kdm.provider.data.FacetEntry");
      entity.setEntries(java_util_ArrayList.demarshall(obj.get("entries"), a1));
    }
    if ((obj.containsKey("field")) && (!obj.get("field").isNull())) {
      entity.setField(obj.get("field").isObject() != null ? Enum.valueOf(Field.class, obj.get("field").isObject().get("^EnumStringValue").isString().stringValue()) : obj.get("field").isString() != null ? Enum.valueOf(Field.class, obj.get("field").isString().stringValue()) : null);
    }
    return entity;
  }

  public String marshall(Facet a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final StringBuilder json = new StringBuilder("{\"^EncodedType\":\"com.kdm.provider.data.Facet\",\"^ObjectID\"");
    json.append(":\"").append(a1.getObject(a0)).append("\"");
    if (ref) {
      return json.append("}").toString();
    }
    return json.append(",").append("\"count\":").append(java_lang_Long.marshall(a0.getCount(), a1)).append(",").append("\"entries\":").append(java_util_ArrayList.marshall(a0.getEntries(), a1)).append(",").append("\"field\":").append(a0.getField() != null ? new StringBuilder(64).append("{\"^EncodedType\":\"com.kdm.provider.data.Field\",\"^EnumStringValue\":\"").append(a0.getField().name()).append("\"}") : "null").append("}").toString();
  }

  private void lazyInit() {
    if (java_util_ArrayList == null) {
      java_util_ArrayList = Marshalling.getMarshaller(ArrayList.class);
    }
    if (com_kdm_provider_data_Field == null) {
      com_kdm_provider_data_Field = Marshalling.getMarshaller(Field.class);
    }
  }
}