package org.jboss.errai.marshalling.client.api;

import com.kdm.provider.data.FacetEntry;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;

public class Marshaller_for_com_kdm_provider_data_FacetEntry_Impl implements GeneratedMarshaller<FacetEntry> {
  private FacetEntry[] EMPTY_ARRAY = new FacetEntry[0];
  private Marshaller<Long> java_lang_Long = Marshalling.getMarshaller(Long.class);
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  public FacetEntry[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  public FacetEntry demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(FacetEntry.class, objId);
    }
    FacetEntry entity = new FacetEntry();
    a1.recordObject(objId, entity);
    if ((obj.containsKey("key")) && (!obj.get("key").isNull())) {
      entity.setKey(java_lang_Long.demarshall(obj.get("key"), a1));
    }
    if ((obj.containsKey("count")) && (!obj.get("count").isNull())) {
      entity.setCount(java_lang_Long.demarshall(obj.get("count"), a1));
    }
    if ((obj.containsKey("term")) && (!obj.get("term").isNull())) {
      entity.setTerm(java_lang_String.demarshall(obj.get("term"), a1));
    }
    return entity;
  }

  public String marshall(FacetEntry a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final StringBuilder json = new StringBuilder("{\"^EncodedType\":\"com.kdm.provider.data.FacetEntry\",\"^ObjectID\"");
    json.append(":\"").append(a1.getObject(a0)).append("\"");
    if (ref) {
      return json.append("}").toString();
    }
    return json.append(",").append("\"key\":").append(java_lang_Long.marshall(a0.getKey(), a1)).append(",").append("\"count\":").append(java_lang_Long.marshall(a0.getCount(), a1)).append(",").append("\"term\":").append(java_lang_String.marshall(a0.getTerm(), a1)).append("}").toString();
  }

  private void lazyInit() {

  }
}